diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/TaskRequest.java AndroidSource/frameworks/base/services/java/com/android/server/distribute/TaskRequest.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/TaskRequest.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/distribute/TaskRequest.java	2015-01-27 14:50:57.000000000 +0900
@@ -0,0 +1,17 @@
+package com.android.server.distribute;
+
+import java.io.Serializable;
+import java.util.ArrayList;
+
+public class TaskRequest implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+	public String name;
+	public ArrayList<Object> parameters;
+	
+	public TaskRequest(String name, ArrayList<Object> parameters)
+	{
+		this.name = name;
+		this.parameters = parameters;
+	}
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/location/GpsLocationProvider.java AndroidSource/frameworks/base/services/java/com/android/server/location/GpsLocationProvider.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/location/GpsLocationProvider.java	2016-01-29 15:12:34.499488000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/location/GpsLocationProvider.java	2015-08-11 10:14:32.000000000 +0900
@@ -748,7 +748,7 @@
             if (mEnabled) return;
             mEnabled = true;
         }
-
+        Log.d(TAG, "HELLOOOOO: " + mEnabled);
         sendMessage(ENABLE, 1, null);
     }
 
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/location/RemoteLocationProvider.java AndroidSource/frameworks/base/services/java/com/android/server/location/RemoteLocationProvider.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/location/RemoteLocationProvider.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/location/RemoteLocationProvider.java	2016-03-02 20:32:33.000000000 +0900
@@ -0,0 +1,153 @@
+package com.android.server.location;
+
+import java.io.FileDescriptor;
+import java.io.PrintWriter;
+
+import com.android.internal.location.ProviderProperties;
+import com.android.internal.location.ProviderRequest;
+
+import android.content.Context;
+import android.location.Criteria;
+import android.location.LocationManager;
+import android.location.LocationProvider;
+import android.os.Bundle;
+import android.os.ServiceManager;
+import android.os.WorkSource;
+import android.service.remote.IRemoteService;
+
+public class RemoteLocationProvider implements LocationProviderInterface 
+{
+	//private final String mName;
+    private final ProviderProperties mProperties = new ProviderProperties(
+            false, false, false, false, false, false, false,
+            Criteria.POWER_LOW, Criteria.ACCURACY_COARSE);
+    
+    //private final ILocationManager mLocationManager;
+
+    //private final Location mLocation;
+    private final Bundle mExtras = new Bundle();
+
+    private int mStatus;
+    private long mStatusUpdateTime;
+    private boolean mHasLocation;
+    private boolean mHasStatus;
+    private boolean mEnabled;
+    
+    private IRemoteService mRemoteService;
+
+    private static final String TAG = "RemoteLocationProvider";
+
+    public RemoteLocationProvider()
+    {
+    	mRemoteService = IRemoteService.Stub.asInterface(ServiceManager
+				.getService(Context.REMOTE_SERVICE));
+    }
+    
+    /*public RemoteLocationProvider(String name, ILocationManager locationManager,
+            ProviderProperties properties) {
+        if (properties == null) throw new NullPointerException("properties is null");
+
+        mName = name;
+        mLocationManager = locationManager;
+        mProperties = properties;
+        mLocation = new Location(name);
+    }*/
+
+    @Override
+    public String getName() {
+        return LocationManager.REMOTE_PROVIDER;
+    }
+
+    @Override
+    public ProviderProperties getProperties() {
+        return mProperties;
+    }
+
+    @Override
+    public void disable() {
+        mEnabled = false;
+    }
+
+    @Override
+    public void enable() {
+    	//if(mRemoteService)
+        mEnabled = true;
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return mEnabled;
+    }
+
+    @Override
+    public int getStatus(Bundle extras) {
+        if (mHasStatus) {
+            extras.clear();
+            extras.putAll(mExtras);
+            return mStatus;
+        } else {
+            return LocationProvider.AVAILABLE;
+        }
+    }
+
+    @Override
+    public long getStatusUpdateTime() {
+        //return mStatusUpdateTime;
+    	return -1;
+    }
+
+    /*public void setLocation(Location l) {
+        mLocation.set(l);
+        mHasLocation = true;
+        if (mEnabled) {
+            try {
+                mLocationManager.reportLocation(mLocation, false);
+            } catch (RemoteException e) {
+                Log.e(TAG, "RemoteException calling reportLocation");
+            }
+        }
+    }*/
+
+    /*public void clearLocation() {
+        mHasLocation = false;
+    }
+
+    public void setStatus(int status, Bundle extras, long updateTime) {
+        mStatus = status;
+        mStatusUpdateTime = updateTime;
+        mExtras.clear();
+        if (extras != null) {
+            mExtras.putAll(extras);
+        }
+        mHasStatus = true;
+    }
+
+    public void clearStatus() {
+        mHasStatus = false;
+        mStatusUpdateTime = 0;
+    }*/
+
+    @Override
+    public void dump(FileDescriptor fd, PrintWriter pw, String[] args) {
+        dump(pw, "");
+    }
+
+    public void dump(PrintWriter pw, String prefix) {
+        /*pw.println(prefix + mName);
+        pw.println(prefix + "mHasLocation=" + mHasLocation);
+        pw.println(prefix + "mLocation:");
+        mLocation.dump(new PrintWriterPrinter(pw), prefix + "  ");
+        pw.println(prefix + "mHasStatus=" + mHasStatus);
+        pw.println(prefix + "mStatus=" + mStatus);
+        pw.println(prefix + "mStatusUpdateTime=" + mStatusUpdateTime);
+        pw.println(prefix + "mExtras=" + mExtras);*/
+    }
+
+    @Override
+    public void setRequest(ProviderRequest request, WorkSource source) { }
+
+    @Override
+    public boolean sendExtraCommand(String command, Bundle extras) {
+        return false;
+    }
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/LocationManagerService.java AndroidSource/frameworks/base/services/java/com/android/server/LocationManagerService.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/LocationManagerService.java	2016-01-29 15:12:34.471488000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/LocationManagerService.java	2016-03-02 20:32:10.000000000 +0900
@@ -53,12 +53,15 @@
 import android.os.PowerManager;
 import android.os.Process;
 import android.os.RemoteException;
+import android.os.ServiceManager;
 import android.os.SystemClock;
 import android.os.UserHandle;
 import android.os.WorkSource;
 import android.provider.Settings;
+import android.service.remote.IRemoteService;
 import android.util.Log;
 import android.util.Slog;
+
 import com.android.internal.content.PackageMonitor;
 import com.android.internal.location.ProviderProperties;
 import com.android.internal.location.ProviderRequest;
@@ -75,6 +78,7 @@
 import com.android.server.location.LocationProviderProxy;
 import com.android.server.location.MockProvider;
 import com.android.server.location.PassiveProvider;
+import com.android.server.location.RemoteLocationProvider;
 
 import java.io.FileDescriptor;
 import java.io.PrintWriter;
@@ -147,6 +151,9 @@
     private LocationWorkerHandler mLocationHandler;
     private PassiveProvider mPassiveProvider;  // track passive provider for special cases
     private LocationBlacklist mBlacklist;
+    
+    // ADDED BY JH
+    private IRemoteService mRemoteService;
 
     // --- fields below are protected by mLock ---
     // Set of providers that are explicitly enabled
@@ -197,6 +204,8 @@
         super();
         mContext = context;
         mAppOps = (AppOpsManager)context.getSystemService(Context.APP_OPS_SERVICE);
+        mRemoteService = IRemoteService.Stub.asInterface(ServiceManager
+				.getService(Context.REMOTE_SERVICE));
 
         if (D) Log.d(TAG, "Constructed");
 
@@ -353,6 +362,11 @@
             addProviderLocked(gpsProvider);
             mRealProviders.put(LocationManager.GPS_PROVIDER, gpsProvider);
         }
+        
+        // ADDED BY JH
+       /* RemoteLocationProvider remoteProvider = new RemoteLocationProvider();
+        addProviderLocked(remoteProvider);
+        mEnabledProviders.add(remoteProvider.getName());*/
 
         /*
         Load package name(s) containing location provider support.
@@ -1200,6 +1214,7 @@
         }
 
         if (enabled) {
+        	Log.d(TAG, "uPLL provider: " + provider + "enabled: " + enabled);
             p.enable();
             if (listeners > 0) {
                 applyRequirementsLocked(provider);
@@ -1488,6 +1503,7 @@
         }
 
         boolean isProviderEnabled = isAllowedByUserSettingsLocked(name, uid);
+        Log.d(TAG, "Hello: " + isProviderEnabled);
         if (isProviderEnabled) {
             applyRequirementsLocked(name);
         } else {
@@ -1864,6 +1880,18 @@
             Log.w(TAG, "Dropping incomplete location: " + location);
             return;
         }
+        
+        // ADDED BY JH
+        Log.d("APP ", "location start!");
+        try
+		{
+			mRemoteService.sendLocation(location);
+		} catch (RemoteException e)
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+        // ADDED BY JH
 
         mLocationHandler.removeMessages(MSG_LOCATION_CHANGED, location);
         Message m = Message.obtain(mLocationHandler, MSG_LOCATION_CHANGED, location);
@@ -2329,6 +2357,34 @@
         }
     }
 
+    // ADDED BY JH
+    @Override
+	public void setRemoteProviderEnabled(boolean enabled)
+			throws RemoteException
+	{
+    	synchronized (mLock) 
+    	{
+    		Log.d(TAG, "Enabled: " + enabled);
+    		
+    		long identity = Binder.clearCallingIdentity();
+            if (enabled) {
+            	RemoteLocationProvider provider = new RemoteLocationProvider();
+                addProviderLocked(provider);
+                provider.enable();
+                mEnabledProviders.add(provider.getName());
+                mDisabledProviders.remove(provider.getName());
+            } else {
+            	LocationProviderInterface provider = mProvidersByName.get(LocationManager.REMOTE_PROVIDER);
+            	removeProviderLocked(provider);
+                provider.disable();
+                mEnabledProviders.remove(provider.getName());
+                mDisabledProviders.add(provider.getName());
+            }
+            updateProvidersLocked();
+            Binder.restoreCallingIdentity(identity);
+        }
+	}
+    
     private void log(String log) {
         if (Log.isLoggable(TAG, Log.VERBOSE)) {
             Slog.d(TAG, log);
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/MainLooperSpy.java AndroidSource/frameworks/base/services/java/com/android/server/remote/MainLooperSpy.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/MainLooperSpy.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/MainLooperSpy.java	2014-12-27 01:23:50.000000000 +0900
@@ -0,0 +1,48 @@
+package com.android.server.remote;
+
+import java.lang.reflect.Field;
+
+import android.os.Looper;
+import android.os.Message;
+import android.os.MessageQueue;
+import android.util.Log;
+
+public class MainLooperSpy {
+	  private final Field messagesField;
+	  private final Field nextField;
+	  private final MessageQueue mainMessageQueue;
+
+	  public MainLooperSpy() {
+	    try {
+	      Field queueField = Looper.class.getDeclaredField("mQueue");
+	      queueField.setAccessible(true);
+	      messagesField = MessageQueue.class.getDeclaredField("mMessages");
+	      messagesField.setAccessible(true);
+	      nextField = Message.class.getDeclaredField("next");
+	      nextField.setAccessible(true);
+	      Looper mainLooper = Looper.getMainLooper();
+	      mainMessageQueue = (MessageQueue) queueField.get(mainLooper);
+	    } catch (Exception e) {
+	      throw new RuntimeException(e);
+	    }
+	  }
+
+	  public void dumpQueue() {
+	    try {
+	      Message nextMessage = (Message) messagesField.get(mainMessageQueue);
+	      Log.d("MainLooperSpy", "Begin dumping queue");
+	      dumpMessages(nextMessage);
+	      Log.d("MainLooperSpy", "End dumping queue");
+	    } catch (IllegalAccessException e) {
+	      throw new RuntimeException(e);
+	    }
+	  }
+
+	  public void dumpMessages(Message message) throws IllegalAccessException {
+	    if (message != null) {
+	      Log.d("MainLooperSpy", message.toString());
+	      Message next = (Message) nextField.get(message);
+	      dumpMessages(next);
+	    }
+	  }
+	}
\ No newline at end of file
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/ObjectSizeCalculator.java AndroidSource/frameworks/base/services/java/com/android/server/remote/ObjectSizeCalculator.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/ObjectSizeCalculator.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/ObjectSizeCalculator.java	2015-10-22 09:34:34.000000000 +0900
@@ -0,0 +1,190 @@
+package com.android.server.remote;
+
+import java.lang.reflect.Field;
+import java.lang.reflect.Modifier;
+import java.util.HashSet;
+import java.util.Set;
+
+public class ObjectSizeCalculator
+{
+
+	private static final int REFERENCE_SIZE;
+	private static final int HEADER_SIZE;
+	private static final int LONG_SIZE = 8;
+	private static final int INT_SIZE = 4;
+	private static final int BYTE_SIZE = 1;
+	private static final int BOOLEAN_SIZE = 1;
+	private static final int CHAR_SIZE = 2;
+	private static final int SHORT_SIZE = 2;
+	private static final int FLOAT_SIZE = 4;
+	private static final int DOUBLE_SIZE = 8;
+	private static final int ALIGNMENT = 8;
+
+	static
+	{
+		try
+		{
+			if (System.getProperties().get("java.vm.name").toString()
+					.contains("64"))
+			{
+				// java.vm.name is something like “Java HotSpot(TM) 64-Bit
+				// Server VM”
+				REFERENCE_SIZE = 8;
+				HEADER_SIZE = 16;
+			} else
+			{
+				REFERENCE_SIZE = 4;
+				HEADER_SIZE = 8;
+			}
+		} catch (Exception ex)
+		{
+			ex.printStackTrace();
+			throw new AssertionError(ex);
+		}
+	}
+
+	public static long sizeOf(Object o) throws IllegalAccessException
+	{
+		return sizeOf(o, new HashSet());
+	}
+
+	private static long sizeOf(Object o, Set visited)
+			throws IllegalAccessException
+	{
+		if (o == null)
+		{
+			return 0;
+		}
+		ObjectWrapper objectWrapper = new ObjectWrapper(o);
+		if (visited.contains(objectWrapper))
+		{
+			// We have reference graph with cycles.
+			return 0;
+		}
+		visited.add(objectWrapper);
+		long size = HEADER_SIZE;
+		Class clazz = o.getClass();
+		if (clazz.isArray())
+		{
+			if (clazz == long[].class)
+			{
+				long[] objs = (long[]) o;
+				size += objs.length * LONG_SIZE;
+			} else if (clazz == int[].class)
+			{
+				int[] objs = (int[]) o;
+				size += objs.length * INT_SIZE;
+			} else if (clazz == byte[].class)
+			{
+				byte[] objs = (byte[]) o;
+				size += objs.length * BYTE_SIZE;
+			} else if (clazz == boolean[].class)
+			{
+				boolean[] objs = (boolean[]) o;
+				size += objs.length * BOOLEAN_SIZE;
+			} else if (clazz == char[].class)
+			{
+				char[] objs = (char[]) o;
+				size += objs.length * CHAR_SIZE;
+			} else if (clazz == short[].class)
+			{
+				short[] objs = (short[]) o;
+				size += objs.length * SHORT_SIZE;
+			} else if (clazz == float[].class)
+			{
+				float[] objs = (float[]) o;
+				size += objs.length * FLOAT_SIZE;
+			} else if (clazz == double[].class)
+			{
+				double[] objs = (double[]) o;
+				size += objs.length * DOUBLE_SIZE;
+			} else
+			{
+				Object[] objs = (Object[]) o;
+				for (int i = 0; i < objs.length; i++)
+				{
+					size += sizeOf(objs[i], visited) + REFERENCE_SIZE;
+				}
+			}
+			size += INT_SIZE;
+		} else
+		{
+			Field[] fields = o.getClass().getDeclaredFields();
+			for (int i = 0; i < fields.length; i++)
+			{
+				if (Modifier.isStatic(fields[i].getModifiers()))
+				{
+					continue;
+				}
+				fields[i].setAccessible(true);
+				String fieldType = fields[i].getGenericType().toString();
+				if (fieldType.equals("long"))
+				{
+					size += LONG_SIZE;
+				} else if (fieldType.equals("int"))
+				{
+					size += INT_SIZE;
+				} else if (fieldType.equals("byte"))
+				{
+					size += BYTE_SIZE;
+				} else if (fieldType.equals("boolean"))
+				{
+					size += BOOLEAN_SIZE;
+				} else if (fieldType.equals("char"))
+				{
+					size += CHAR_SIZE;
+				} else if (fieldType.equals("short"))
+				{
+					size += SHORT_SIZE;
+				} else if (fieldType.equals("float"))
+				{
+					size += FLOAT_SIZE;
+				} else if (fieldType.equals("double"))
+				{
+					size += DOUBLE_SIZE;
+				} else
+				{
+					size += sizeOf(fields[i].get(o), visited) + REFERENCE_SIZE;
+				}
+			}
+		}
+		if ((size % ALIGNMENT) != 0)
+		{
+			size = ALIGNMENT * (size / ALIGNMENT) + ALIGNMENT;
+		}
+		return size;
+	}
+
+	private static final class ObjectWrapper
+	{
+
+		private Object object;
+
+		public ObjectWrapper(Object object)
+		{
+			this.object = object;
+		}
+
+		@Override
+		public boolean equals(Object obj)
+		{
+			if (obj == this)
+			{
+				return true;
+			}
+			if ((obj == null) || (obj.getClass() != ObjectWrapper.class))
+			{
+				return false;
+			}
+			return object == ((ObjectWrapper) obj).object;
+		}
+
+		@Override
+		public int hashCode()
+		{
+			int hash = 3;
+			hash = 47 * hash + System.identityHashCode(object);
+			return hash;
+		}
+	}
+}
